using Indotalent.Infrastructure.Database;
using MediatR;
using Microsoft.EntityFrameworkCore;

namespace Indotalent.Features.Inventory.TransferOut.Cqrs;

public class UpdateTransferOutItemRequest
{
    public string? Id { get; set; }
    public string? ProductId { get; set; }
    public double? Movement { get; set; }
}

public record UpdateTransferOutItemCommand(UpdateTransferOutItemRequest Data) : IRequest<bool>;

public class UpdateTransferOutItemHandler : IRequestHandler<UpdateTransferOutItemCommand, bool>
{
    private readonly AppDbContext _context;
    public UpdateTransferOutItemHandler(AppDbContext context) => _context = context;

    public async Task<bool> Handle(UpdateTransferOutItemCommand request, CancellationToken cancellationToken)
    {
        var entity = await _context.InventoryTransaction
            .FirstOrDefaultAsync(x => x.Id == request.Data.Id, cancellationToken);

        if (entity == null) return false;

        entity.ProductId = request.Data.ProductId;
        entity.Movement = request.Data.Movement;

        _context.CalculateInvenTrans(entity);
        await _context.SaveChangesAsync(cancellationToken);

        return true;
    }
}